// FcavPacketTb.v
//

`include "FcavPacketTimescale.v"

module FcavPacketTb();

// Inputs

reg             clock;                    
initial         clock = 1'b0;              

reg             reset_n;                  
initial         reset_n = 1'b1;            

reg[7:0]        data_in;        
initial         data_in = 8'b0;  

reg             data_in_valid;  
initial         data_in_valid = 1'b0; 	   
	
reg				frame_pulse_in;
initial 		frame_pulse_in = 1'b0;

// Outputs

wire[7:0]       data_out;       
wire            data_out_valid; 
wire 			frame_pulse_out;

// Generate clock
initial
begin // clock
	clock = 1'b1;
	forever #500 clock = !clock;
end

// Instance of the DUT
FcavPacket FcavPacket1(
	.clock(clock),
	.reset_n(reset_n),
	.data_in(data_in),
	.data_in_valid(data_in_valid),  
	.frame_pulse_in(frame_pulse_in),
	.data_out(data_out),
	.data_out_valid(data_out_valid),
	.frame_pulse_out(frame_pulse_out)
	);

endmodule

`include "FcavPacketSpv.v"

//
// End of: FcavPacketTb.v
