#include "SigSlice.h"
#include "Spv2DArray.h"

SigSlice::SigSlice(){
}

SigSlice::SigSlice(string sigName, unsigned from, unsigned to){
	Init(sigName, from, to);
}

bool SigSlice::Init(string sigName, unsigned from, unsigned to){
	if(!SpvSig::IsSigExists(sigName)) {
		SPV_ERROR("SigSlice::Init - Signal " + sigName + " does not exist");
		return false;
	}

	SpvVirSig::Init(sigName);
	m_From	= from;
	m_To	= to;	
	m_Sig	= new SpvSig(sigName);

	return true;
}

 
unsigned SigSlice::Eval(){
	return (*m_Sig)(m_From,m_To).Uint();
}