#include "FcavExtPacketData.h"

FcavPacketElemGen::FcavPacketElemGen()
{
	m_Gen = NULL;
	Init(32,0);

	int genType = (unsigned)UseVal;
	SD::GetInt(genType,"FCAV_PACKET_DEF_ELEM_GEN");
	m_GenType = (FcavGenType)genType;
}

FcavPacketElemGen::FcavPacketElemGen(const unsigned bitSize, unsigned value)
{
	Init(bitSize,value);
}

FcavPacketElemGen::FcavPacketElemGen(SpvGen *userGen)
{
	Init(userGen);
}

void FcavPacketElemGen::Init(const unsigned bitSize, unsigned value)
{
	m_Cntr = 0;

	m_Value.Resize(bitSize);

	SetSize(bitSize);
	SetVal(value, true);
}

void FcavPacketElemGen::Init(SpvGen *userGen)
{
	m_Cntr = 0;

	m_Value.Resize(userGen->Size());

	SetSize(userGen->Size());
	SetGen(userGen);
}

unsigned FcavPacketElemGen::Gen()
{
	switch (m_GenType) {
	case UseGen :
		m_LastGen = m_Gen->Gen();
		break;
	case UseRandom:
		m_LastGen = GenUnsigned();
		break;
	case UseCnt:
		m_LastGen = m_Cntr++;
		break;
	case UseVal:
		m_LastGen = m_Value;
		break;
	default: 
		m_LastGen = 0;
		break;
	}

	return m_LastGen.Uint();
}

void FcavPacketElemGen::SetVal(unsigned value, bool updateLastVal)
{
	m_GenType = UseVal;
	m_Value = value;

	if(updateLastVal)
		m_LastGen = m_Value;
}

void FcavPacketElemGen::SetBitVec(SpvBitVec value, bool updateLastVal)
{
	m_GenType = UseVal;

	if(value.Size() != Size())
	{
		m_Value.Resize(value.Size());
		SetSize(value.Size());
	}
	m_Value = value;
	
	if(updateLastVal)
		m_LastGen = m_Value;
}

void FcavPacketElemGen::SetGen(SpvGen *userGen)
{
	m_GenType = UseGen;

	if(userGen->Size() != Size())
	{
		m_Value.Resize(userGen->Size());
		SetSize(userGen->Size());
	}
	m_Gen = userGen;
}
