#if !defined(FCAV_PACKET_)
#define FCAV_PACKET_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FcavPacketContainerHdr.h"
#include "FcavPacketDataHdr.h"
#include "FcavPacketData.h"

/////////////////////////////////////////////////////////////////////////////
//////			     FC-AV Packet - Structure						  ///////
/////////////////////////////////////////////////////////////////////////////
class FcavPacketStruct : public SpvPacket
{
protected:
	//! FC-AV Container Header Contained within the Anonymous Subscriber Messages (ASM) Message Payload
	FcavPacketContainerHdr	m_ContainerHdr;			// 6 Words

	//! FC-AV Objects Header
	FcavPacketDataHdr		m_DataHdr;				// 16 Words

	//! FC-AV Data
	FcavPacketData			m_Data;					// 15.9 Mbytes

public:
	FcavPacketStruct();
};

/////////////////////////////////////////////////////////////////////////////
//////			     FC-AV Packet - Generator						  ///////
/////////////////////////////////////////////////////////////////////////////
class FcavPacketGenerator : public SpvPacketGen <FcavPacketStruct>
{
protected:
	ExtPacketData						*m_PacketData;
	FcavPacketContainerHdrGenerator		m_ContainerHdrGenerator;
	FcavPacketDataHdrGenerator			m_DataHdrGenerator;
	FcavPacketDataGenerator				m_DataGenerator;

public:
	FcavPacketGenerator(ExtPacketData *packetData);

	virtual void InitKeepConstrains();
};


#endif