#include "FcavPacketDataHdr.h"

/////////////////////////////////////////////////////////////////////////////
//////			         FC-AV Data Header - Structure				  ///////
/////////////////////////////////////////////////////////////////////////////
FcavPacketObjectN::FcavPacketObjectN() 
{
	m_ObjectIndex.MakePhysical(this,16);
	m_ObjectLinkPointer.MakePhysical(this,8);
	m_ObjectType.MakePhysical(this,8);	
	m_ObjectSize.MakePhysical(this,32);
	m_ObjectOffset.MakePhysical(this,32);
	m_ObjectTypeDef.MakePhysical(this,32);
}

FcavPacketDataHdr::FcavPacketDataHdr() 
{
	m_Object0.MakePhysical(this);
	m_Object1.MakePhysical(this);
	m_Object2.MakePhysical(this);
	m_Object3.MakePhysical(this);
}

/////////////////////////////////////////////////////////////////////////////
//////			         FC-AV Data Header - Generator			      ///////
/////////////////////////////////////////////////////////////////////////////
FcavPacketObjectNGenerator::FcavPacketObjectNGenerator(ExtPacketData *packetData, int objectNum)
{
	m_ObjectNum		= objectNum;
	m_PacketData	= packetData;
	InitKeepConstrains();
}

void FcavPacketObjectNGenerator::InitKeepConstrains()
{
	KeepGeneration(m_ObjectIndex,			&m_PacketData->m_ObjectNIndexGen[m_ObjectNum],		"ObjectIndex" +Itos(m_ObjectNum));
	KeepGeneration(m_ObjectLinkPointer,		&m_PacketData->m_ObjectNLinkPtrGen[m_ObjectNum],	"ObjectLinkPointer" +Itos(m_ObjectNum));
	KeepGeneration(m_ObjectType,			&m_PacketData->m_ObjectNTypeGen[m_ObjectNum],		"ObjectType" +Itos(m_ObjectNum));
	//KeepGeneration(m_ObjectSize,			&m_PacketData->m_ObjectNSizeGen[m_ObjectNum],		"ObjectSize" +Itos(m_ObjectNum));
	
	m_UsrData.m_Value = m_ObjectNum;
	m_UsrData.m_AnyPtr = (void*)m_PacketData;

	KeepUserData(m_ObjectOffset,			&m_UsrData,		"ObjectOffset"+Itos(m_ObjectNum));
	KeepUserData(m_ObjectSize,				&m_UsrData,		"ObjectSize"+Itos(m_ObjectNum));
	
	KeepGeneration(m_ObjectTypeDef,&m_PacketData->m_ObjectNTypeDefGen[m_ObjectNum],"ObjectTypeDef" +Itos(m_ObjectNum));
}

FcavPacketDataHdrGenerator::FcavPacketDataHdrGenerator(ExtPacketData *packetData) :
	m_Object0Generator(packetData, 0),	
	m_Object1Generator(packetData, 1),
	m_Object2Generator(packetData, 2),
	m_Object3Generator(packetData, 3)
{
	m_PacketData = packetData;
	InitKeepConstrains();
}

void FcavPacketDataHdrGenerator::InitKeepConstrains()
{
	KeepNestedPacket(m_Object0,	&m_Object0Generator,	"OBJECT0");
	KeepNestedPacket(m_Object1,	&m_Object1Generator,	"OBJECT1");
	KeepNestedPacket(m_Object2,	&m_Object2Generator,	"OBJECT2");
	KeepNestedPacket(m_Object3,	&m_Object3Generator,	"OBJECT3");	
}