// FcavPacketCol.h: interface for the FcavPacketCol class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FCAVPACKETCOL_H__CD6CF61D_0C39_4277_A9E8_43D440C62935__INCLUDED_)
#define AFX_FCAVPACKETCOL_H__CD6CF61D_0C39_4277_A9E8_43D440C62935__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <deque>
#include "FcavPacketPacket.h"
#include <SpvPlugin.h>
#include "../Fcav/FcavPacket.h"
#include "SpvImage.h"
#include "../Common/CommonDefs.h"

class FcavPacketCol : public SpvBase  
{
public:
	FcavPacketCol();
	virtual ~FcavPacketCol();

	virtual void Start();

protected:
	virtual void PacketInThread();

	virtual void PacketOutThread();

	virtual void PacketRestartCompare();

    virtual unsigned TransferFunc(unsigned input);

    virtual bool Compare(unsigned expected, unsigned received);

	virtual void BuildFcavPacket();


protected:
	SpvSig			m_SigClock,		m_SigReset;
	SpvSig			m_SigDataIn,	m_SigDataInValid;
	SpvSig			m_SigDataOut,	m_SigDataOutValid;
	SpvSig			m_SigFramePulse;
	
	SpvEvent		m_PosClock, m_NegClock, m_PosReset, m_NegReset;

	SpvImage		m_OddImage, m_EvenImage, m_FullImage;
	
	std::vector <SpvTProcCtrl*>	m_ThreadCtrls;

	FcavPacketStruct	*m_FcavPacketUsr;
	ExtPacketData		m_PacketDataUsr;
	FcavPacketGenerator *m_FcavPacketGenUsr;
	bool				m_PrintGoodData;
	unsigned			m_FcavFrameCnt, m_ImageCnt;
	
	deque <unsigned> m_Fifo;

};

#endif // !defined(AFX_FcavPacketCol_H__CD6CF61D_0C39_4277_A9E8_43D440C62935__INCLUDED_)
