// FcavPacketDriver.h: interface for the FcavPacketDriver class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FCAVPACKETDRIVER_H__754AEF68_0CDB_49AF_ADAB_036276BD2A6E__INCLUDED_)
#define AFX_FCAVPACKETDRIVER_H__754AEF68_0CDB_49AF_ADAB_036276BD2A6E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FcavPacketPacket.h"
#include <SpvPlugin.h>
#include "../Fcav/FcavPacket.h"
#include "SpvImage.h"
#include "../Common/CommonDefs.h"

class FcavPacketDriver : public SpvBase 
{
	SpvSig				m_SigClock, m_SigReset;

	SpvSig				m_SigDataIn, m_SigDataInValid, m_SigFramePulse;
	
	SpvGen				*m_DataEnGen;

	SpvEvent			m_PosClock, m_PosReset, m_NegReset;

	std::vector <SpvTProcCtrl*>	m_ThreadCtrls;

	unsigned			m_FcavFrameCnt, m_ImageCnt;

	FcavPacketStruct	*m_FcavPacketUsr;
	ExtPacketData		m_PacketDataUsr;
	FcavPacketGenerator *m_FcavPacketGenUsr;
	SpvBitVec			m_PacketVec;
	unsigned			m_PacketPos;
	SpvBitVec			m_PixVal;

protected:
	bool Gen();

public:
	FcavPacketDriver();
	virtual ~FcavPacketDriver();

	virtual void Start();

	virtual bool MakePacket(SpvBitVec &currPacketVec);

	virtual void ThreadReset();
	
	virtual void ThreadDriveData();
	
	virtual void ThreadRestartData();

};

#endif // !defined(AFX_FCAVPACKETDRIVER_H__754AEF68_0CDB_49AF_ADAB_036276BD2A6E__INCLUDED_)
